## macaulay2 1.21+ds

=== mike/Makefile ===
TESTFILES = 0-GF-division.m2

a:
	@ set -ex ; for i in $(TESTFILES) ; do $$M2BUILDDIR/M2 --stop -e " input \"$$i\" ; exit 0 " ; done

=== BUILD/david/Makefile ===
all:
	$(MAKE) -C build.tmp all install
configure:
	cd ../..; make -f Makefile
	mkdir -p build.tmp 
	cd build.tmp; ../../../configure --enable-download --prefix=$(HOME)/Macaulay2-built CPPFLAGS="-I/usr/local/include -I/usr/local/opt/readline/include" LDFLAGS="-L/usr/local/lib -L/usr/local/opt/readline/lib" CC="gcc-4.9 -m64" CXX="g++-4.9 -m64" --build=x86_64-apple-darwin

veryclean :
	rm -rf build.tmp

=== BUILD/mike/Makefile ===
.PHONY: always
always:

BRANCH := $(shell git branch --contains | grep '^\* ' | sed -e s=^..== -e s=/=.=g )

BREWPREFIX := `brew --prefix`

#######################
## cmake build files ##
#######################

cmake-make-appleclang:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-make-appleclang-$(BRANCH)
	cd builds.tmp/cmake-make-appleclang-$(BRANCH); cmake \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_INSTALL_PREFIX=`pwd`/installed \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

#		-DLINTING=on

cmake-tbb2020-appleclang:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-tbb2020-appleclang
	cd builds.tmp/cmake-tbb2020-appleclang; cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_PREFIX_PATH="`brew --prefix tbb@2020`;`brew --prefix`" \
		-DBUILD_NATIVE=off \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-no-tbb-appleclang:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-no-tbb-appleclang
	cd builds.tmp/cmake-no-tbb-appleclang; cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_PREFIX_PATH=`brew --prefix` \
		-DWITH_TBB=off \
		-DBUILD_NATIVE=off \
		-DBUILD_TESTING=off \
		-DBUILD_DOCS=on \
		../../../..

cmake-appleclang:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-appleclang
	cd builds.tmp/cmake-appleclang; cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DCMAKE_PREFIX_PATH="`brew --prefix tbb@2021`;`brew --prefix libffi`;`brew --prefix`" \
		-DBUILD_NATIVE=off \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-debug-appleclang:
	mkdir -p builds.tmp/cmake-debug-appleclang
	cd builds.tmp/cmake-debug-appleclang; cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=Debug \
		-DCMAKE_PREFIX_PATH="`brew --prefix tbb@2021`;`brew --prefix libffi`;`brew --prefix`" \
		-DBUILD_NATIVE=off \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-profile-appleclang:
	echo "git branch is " $(BRANCH)
	mkdir -p builds.tmp/cmake-profile-appleclang
	cd builds.tmp/cmake-profile-appleclang; cmake \
		-GNinja \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DPROFILING=on \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..
#		-DLINTING=on

cmake-latestclang:
	mkdir -p builds.tmp/cmake-latestclang
	cd builds.tmp/cmake-latestclang; LIBRARY_PATH=`/usr/local/opt/llvm/bin/llvm-config --libdir` cmake \
		-GNinja \
	    -DCMAKE_C_COMPILER:FILEPATH=/usr/local/opt/llvm/bin/clang \
		-DCMAKE_CXX_COMPILER:FILEPATH=/usr/local/opt/llvm/bin/clang++ \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-debug-latestclang:
	mkdir -p builds.tmp/cmake-debug-latestclang
	cd builds.tmp/cmake-debug-latestclang; cmake \
		-GNinja \
	    -DCMAKE_C_COMPILER:FILEPATH=/usr/local/opt/llvm/bin/clang \
		-DCMAKE_CXX_COMPILER:FILEPATH=/usr/local/opt/llvm/bin/clang++ \
		-DCMAKE_BUILD_TYPE=Debug \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

cmake-gcc9:
	mkdir -p builds.tmp/cmake-gcc9
	cd builds.tmp/cmake-gcc9; cmake \
		-GNinja \
	    -DCMAKE_C_COMPILER:FILEPATH=/usr/local/bin/gcc-9 \
		-DCMAKE_CXX_COMPILER:FILEPATH=/usr/local/bin/g++-9 \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

ubuntu-cmake-gcc:
	mkdir -p builds.tmp/ubuntu-cmake-gcc
	cd builds.tmp/ubuntu-cmake-gcc; cmake \
		-GNinja \
	    -DCMAKE_C_COMPILER:FILEPATH=gcc \
		-DCMAKE_CXX_COMPILER:FILEPATH=g++ \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

# running cmake-gcc9 now: 30 May 2020.
#  build-libraries (with testing off): 22m36s
#  build-programs (with testing off): 12m19s
#  cmake -DBUILD_TESTING=on .
#  M2-core: 2m51s
#  install-packages: (running)
#  M2-unit-tests
#  check-packages
# ctest

cmake-debug-gcc9:
	mkdir -p builds.tmp/cmake-debug-gcc9
	cd builds.tmp/cmake-debug-gcc9; cmake \
		-GNinja \
	    -DCMAKE_C_COMPILER:FILEPATH=/usr/local/bin/gcc-9 \
		-DCMAKE_CXX_COMPILER:FILEPATH=/usr/local/bin/g++-9 \
		-DCMAKE_BUILD_TYPE=Debug \
		-DBUILD_TESTING=on \
		-DBUILD_DOCS=on \
		../../../..

xcode:
	mkdir -p builds.tmp/xcode
	cd builds.tmp/xcode; cmake \
		-GXcode \
		../../../..

###########################
## configure build files ##
###########################

###########
## MacOS ##
###########
# Some possibly useful configure options
# 		--build=x86_64-apple-darwin
#       --enable-build-libraries="flint ntl"

arm64-appleclang : always
	mkdir -p builds.tmp/arm64-appleclang
	cd builds.tmp/arm64-appleclang; ../../../../configure \
		CPPFLAGS="-I`brew --prefix tbb@2021`/include -I`brew --prefix`/include" \
		LDFLAGS="-L`brew --prefix tbb@2021`/lib -L`brew --prefix`/lib" \
	    --with-boost-regex=boost_regex \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

debug-arm64-appleclang : always
	mkdir -p builds.tmp/debug-arm64-appleclang
	cd builds.tmp/debug-arm64-appleclang; ../../../../configure \
		CPPFLAGS="-I`brew --prefix tbb@2021`/include -I`brew --prefix`/include" \
		LDFLAGS="-L`brew --prefix tbb@2021`/lib -L`brew --prefix`/lib" \
	    --with-boost-regex=boost_regex \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-debug \
		--enable-memdebug \
		--disable-optimize \
		--enable-download

arm64-tbb2020-appleclang : always
	mkdir -p builds.tmp/arm64-tbb2020-appleclang
	cd builds.tmp/arm64-tbb2020-appleclang; ../../../../configure \
		CPPFLAGS="-I`brew --prefix tbb@2020`/include -I`brew --prefix`/include" \
		LDFLAGS="-L`brew --prefix tbb@2020`/lib -L`brew --prefix`/lib" \
	    --with-boost-regex=boost_regex \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

arm64-no-tbb-appleclang : always
	mkdir -p builds.tmp/arm64-no-tbb-appleclang
	cd builds.tmp/arm64-no-tbb-appleclang; ../../../../configure \
		CPPFLAGS="-I`brew --prefix tbb@2021`/include -I`brew --prefix`/include" \
		LDFLAGS="-L`brew --prefix tbb@2021`/lib -L`brew --prefix`/lib" \
		--disable-tbb \
	    --with-boost-regex=boost_regex \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

darwin64-appleclang : always
	mkdir -p builds.tmp/darwin64-appleclang
	cd builds.tmp/darwin64-appleclang; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

darwin64-latestclang : always
	mkdir -p builds.tmp/darwin64-latestclang
	cd builds.tmp/darwin64-latestclang; ../../../../configure \
		CC="/usr/local/opt/llvm/bin/clang" \
		CXX="/usr/local/opt/llvm/bin/clang++" \
		LDFLAGS="-L/usr/local/opt/llvm/lib -Wl,-rpath,/usr/local/opt/llvm/lib" \
		CPPFLAGS="-I/usr/local/opt/llvm/include" \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

darwin64-gcc9 : always
	mkdir -p builds.tmp/darwin64-gcc9
	cd builds.tmp/darwin64-gcc9; ../../../../configure \
		CC=gcc-9 CXX=g++-9 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

darwin64-gcc10 : always
	mkdir -p builds.tmp/darwin64-gcc9
	cd builds.tmp/darwin64-gcc9; ../../../../configure \
		CC=gcc-10 CXX=g++-10 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

debug64-latestclang : always
	mkdir -p builds.tmp/debug64-latestclang
	cd builds.tmp/debug64-latestclang; ../../../../configure \
		CC="/usr/local/opt/llvm/bin/clang" \
		CXX="/usr/local/opt/llvm/bin/clang++" \
		LDFLAGS="-L/usr/local/opt/llvm/lib -Wl,-rpath,/usr/local/opt/llvm/lib" \
		CPPFLAGS="-I/usr/local/opt/llvm/include" \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-debug \
		--disable-optimize

debug64-appleclang : always
	mkdir -p builds.tmp/debug64-appleclang
	cd builds.tmp/debug64-appleclang; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-debug \
		--enable-memdebug \
		--disable-optimize

debug64-gcc9 : always
	mkdir -p builds.tmp/debug64-gcc9
	cd builds.tmp/debug64-gcc9; ../../../../configure \
		CC=gcc-9 CXX=g++-9 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-debug \
		--disable-optimize

profile64-latestclang : always
	mkdir -p builds.tmp/profile64-latestclang
	cd builds.tmp/profile64-latestclang; ../../../../configure \
		CC="/usr/local/opt/llvm/bin/clang" \
		CXX="/usr/local/opt/llvm/bin/clang++" \
		LDFLAGS="-L/usr/local/opt/llvm/lib -Wl,-rpath,/usr/local/opt/llvm/lib" \
		CPPFLAGS="-I/usr/local/opt/llvm/include" \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-profile

profile64-appleclang : always
	mkdir -p builds.tmp/profile64-appleclang
	cd builds.tmp/profile64-appleclang; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-profile

profile64-gcc9 : always
	mkdir -p builds.tmp/profile64-gcc9
	cd builds.tmp/profile64-gcc9; ../../../../configure \
		CC=gcc-9 CXX=g++-9 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download \
		--enable-profile

###################
## linux ##########
###################

linux-opt64-gcc8 : always
	mkdir -p builds.tmp/opt64-gcc8
	cd builds.tmp/opt64-gcc8; ../../../../configure \
		CC=gcc-8 CXX=g++-8 \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

linux-opt64 : always
	mkdir -p builds.tmp/opt64
	cd builds.tmp/opt64; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

linux-debug64 : always
	mkdir -p builds.tmp/debug64
	cd builds.tmp/debug64; ../../../../configure \
		--prefix="`pwd`/installed" \
		CPPFLAGS="-DENGINE_DEBUG_" \
		CXXFLAGS=" -U__GNUC_STDC_INLINE__" \
		--enable-debug \
		--disable-optimize \
		--enable-download

linux-profile64 : always
	mkdir -p builds.tmp/profile64
	cd builds.tmp/profile64; ../../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-profile \
		--enable-download

######## below this line is older ######################
opt : always
	mkdir -p opt
	cd opt; ../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-download

debug : always
	mkdir -p debug
	cd debug; ../../../configure \
		--prefix="`pwd`/installed" \
		--enable-debug \
		--disable-strip \
		--disable-optimize \
		--enable-download

profile : always
	mkdir -p profile
	cd profile; ../../../configure \
		--prefix="`pwd`/installed" \
		--disable-strip \
		--enable-profile \
		--enable-download \

# the following is no longer possible for me.
# TODO: work with Dan to fix that.
upload : always
	scp darwin64/*.dmg u00.math.uiuc.edu:/home/html/www/Macaulay2/Uploads

=== Macaulay2/d/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for building M2-interpreter

include(scc) ## CMake macro for calling the Safe C Compiler

# TODO: changing this causes a lot of recompiling
## Configure distributed-packages.h at the destination
string(REPLACE ";" " " DISTRIBUTED_PACKAGES "${DISTRIBUTED_PACKAGES}")
# TODO: configure this header directly in version.dd?
file(GENERATE OUTPUT distributed-packages.h CONTENT "#define DISTRIBUTED_PACKAGES \"${DISTRIBUTED_PACKAGES}\"")

## Configure version.dd at the destination
#configure_file(version.dd.in version.dd #ONLY)

###############################################################################

set(CLIST
  M2types.c M2lib.c M2mem.c types.h
  scclib.c ../c/scc-core.h
  memdebug.c memdebug.h
  debug.c debug.h
  getpagesize.h M2mem.h
  gmp_aux.c gmp_aux.h # TODO: needed with mpir?
  gdbm_interface.c
  )

set(CXXLIST boost-regex.cpp)

# CAUTION: order is important in this list
# TODO: can there be #ifdefs in D sources?
set(DLIST
  arithmetic.d
  atomic.d
  M2.d
  system.d
  strings.d
  varstrin.d
  strings1.d
  errio.d
  vararray.d
  ctype.d
  nets.d
  varnets.d
  interrupts.d
  pthread0.d
  stdiop0.d
  gmp.d
  engine.dd
  xml.d		# removed unless WITH_XML
  stdio0.d
  parse.d
  expr.d
  stdio.d
  stdiop.d
  err.d
  gmp1.d
  tokens.d
  getline.d
  lex.d
  parser.d
  binding.d
  basic.d
  convertr.d
  common.d
  util.d
  struct.d
  classes.dd
  buckets.dd
  equality.dd
  hashtables.dd
  regex.dd
  evaluate.d
  sets.dd
  mysql.d	# removed unless WITH_SQL
  mysqldummy.d	# removed if WITH_SQL
  pthread.d
  actors.d
  actors2.dd
  actors3.d
  actors4.d
  # tasks.d
  xmlactors.d	# removed unless WITH_XML
  actors5.d
  actors6.dd
  threads.dd
  python.d	# removed unless WITH_PYTHON
  interface.dd interface2.d
  texmacs.d
  boostmath.dd
  ffi.d		# removed unless WITH_FFI
  interp.dd	# this one is last, because it contains the top level interpreter
  version.dd
  )

# Generator expressions conflict with the macro below, so manually remove the ones we don't need
if(NOT WITH_XML)
  list(REMOVE_ITEM DLIST xml.d xmlactors.d)
endif()
if(NOT WITH_SQL)
  list(REMOVE_ITEM DLIST mysql.d)
else()
  list(REMOVE_ITEM DLIST mysqldummy.d)
endif()
if(NOT WITH_PYTHON)
  list(REMOVE_ITEM DLIST python.d)
endif()
if(NOT WITH_FFI)
  list(REMOVE_ITEM DLIST ffi.d)
endif()

###############################################################################
## Generate TAGS file
# TODO: the order is somewhat different, is it a problem?

if(ETAGS)
  set(TAGS TAGS)
  set_source_files_properties(TAGS PROPERTIES GENERATED true)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/TAGS
    COMMENT "Generating d/TAGS file"
    COMMAND ${ETAGS} -o TAGS ${CLIST} ${CXXLIST} ${DLIST}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

###############################################################################
## Generate the interpreter

foreach(_d_source IN LISTS DLIST)
  # See cmake/scc.cmake
  _SCC_TRANSLATE(${_d_source} _c) # sets _c_source
  list(APPEND CLIST ${_c_source})
endforeach()

# To avoid unnecessary recompiling, only version.dd is given GIT_DESCRIPTION
set_source_files_properties(version-tmp.cc
  PROPERTIES COMPILE_DEFINITIONS GIT_DESCRIPTION="${GIT_DESCRIPTION}")

###############################################################################
## Compile the interpreter

# TODO: gmp.d, basic.d, and equality.d require elements from M2-engine
# for that reason, interpreter cannot be compiled as a static library, yet
add_library(M2-interpreter OBJECT ${CLIST} ${CXXLIST} ${TAGS}
  distributed-packages.h
  $<$<BOOL:${WITH_XML}>:xml-c.c xml-c.h>
  $<$<BOOL:${WITH_PYTHON}>:python-c.c>)

target_link_libraries(M2-interpreter PRIVATE M2-supervisor Boost::regex TBB::tbb
  $<$<BOOL:${WITH_FFI}>:FFI::ffi>)

target_include_directories(M2-interpreter
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e> # need newdelete.hpp
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/c> # need scc-core.h
    $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/Macaulay2/d>
    # for version.dd to get version numbers
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/mathic>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/memtailor>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/mathicgb>
    # for libraries that the interpreter needs
    $<BUILD_INTERFACE:${READLINE_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${LIBXML2_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${EIGEN3_INCLUDE_DIR}>
    $<INSTALL_INTERFACE:include/Macaulay2>
    $<$<BOOL:${WITH_PYTHON}>:$<BUILD_INTERFACE:${Python3_INCLUDE_DIRS}>>
  PRIVATE
    ${SQLite3_INCLUDE_DIRS}
  )

# TODO: Including most of these is only necessary because of version.dd
# changing or moving that file would allow moving this to e/CMakeLists.txt
foreach(LIB IN LISTS PKGLIB_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC PkgConfig::${LIB})
  endif()
endforeach()

foreach(LIB IN LISTS LIBRARIES_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC ${${LIB}_LIBRARIES})
    target_include_directories(M2-interpreter PUBLIC
        "$<BUILD_INTERFACE:${${LIB}_INCLUDE_DIR}>")
  endif()
endforeach()

foreach(LIB IN LISTS LIBRARY_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC ${${LIB}_LIBRARY})
    target_include_directories(M2-interpreter PUBLIC
        "$<BUILD_INTERFACE:${${LIB}_INCLUDE_DIR}>")
  endif()
endforeach()

# Compiler warning flags
target_compile_options(M2-interpreter PRIVATE
  -Wno-cast-qual # FIXME: caused by M2lib.c:551:43
  -Wno-sign-compare
  -Wno-uninitialized
  -Wno-unused
  -Wno-array-bounds   # FIXME: caused by scc1's implementation of arrays

  # FIXME: mismatched-tags and parentheses-equality errors are caused by scc1
  $<$<COMPILE_LANG_AND_ID:C,AppleClang,Clang>:-Wno-parentheses-equality>
  $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-mismatched-tags -Wno-parentheses-equality>
  # FIXME: caused by SIMD macro redefinition in fflas_ffpack
  $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-macro-redefined>

  # FIXME: __builtin_frame_address M2lib.c:165 causes this:
  $<$<COMPILE_LANG_AND_ID:C,GNU>:-Wno-frame-address>
  # Givaro and fflas_ffpack cause these:
  $<$<COMPILE_LANG_AND_ID:CXX,GNU>:-Wno-deprecated-copy -Wno-unknown-pragmas>
  )
# add other compilers (eg: Intel, MSVC) here
# for Intel: -diag-disable 981,869,383,2259,444 -debug

###############################################################################
## Export the target

install(TARGETS M2-interpreter EXPORT Macaulay2 COMPONENT devel EXCLUDE_FROM_ALL)

=== Macaulay2/e/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for building M2-engine and M2-unit-tests
## memtailor, mathic, and mathicgb are also imported as subdirectories here
## - run unit tests:  ctest -R unit-tests (includes mathicgb and friends)

set(with_tbb ${WITH_TBB}) # for mathicgb

add_subdirectory(memtailor)
add_subdirectory(mathic)
add_subdirectory(mathicgb)

target_compile_options(mathicgb PRIVATE
  -Wall -Wextra -Wno-unused-parameter -Wno-unused-value -Wno-unused-variable -Wno-sign-compare
  -Wno-deprecated-declarations
  )

if(CMAKE_BUILD_TYPE MATCHES "Debug") # Debugging
  add_compile_definitions(MEMT_DEBUG MATHIC_DEBUG MATHICGB_DEBUG)
endif()

###############################################################################
## M2-engine sources

# TODO: determine the fate of these files
set(UNDETERMINED
  dmat-ffpack.cpp
  franzi-brp-test.cpp
  gb-trace.hpp
  overflow-test.cpp
  test.dd
  aring-wrap # both cpp and hpp
  points # both cpp and hpp
  )

# c files
# TODO: convert to cpp or simplify if not needed
# MES TODO:   monordering.c removed this, is that correct?
set(CFILES
  complex.c
  error.c
  exptable.c
  table.c
  )
# h files
set(HFILES
  complex.h
  error.h
  exptable.h
  table.h
  engine.h
  defgroups.h
  mpreal.h
  )

# these files are include only.
set(HPPONLYFILES
  MemoryBlock.hpp
  NCAlgebras/Range.hpp
  VectorArithmetic.hpp
  ARingElem.hpp
  newdelete.hpp
  timing.hpp
  SLP-defs.hpp
  SLP-imp.hpp
  aring-glue.hpp
  aring-qq.hpp
  aring-translate.hpp
  dmat-gf-flint-big.hpp
  dmat-gf-flint.hpp
  dmat-lu-inplace.hpp
  dmat-lu-qq.hpp
  dmat-lu-zzp-ffpack.hpp
  dmat-lu-zzp-flint.hpp
  dmat-lu.hpp
  dmat-qq-flint.hpp
  dmat-qq-interface-flint.hpp
  dmat-zz-flint.hpp
  dmat-zzp-flint.hpp
  engine-includes.hpp
  exceptions.hpp
  geobucket.hpp
  geopoly.hpp
  geovec.hpp
  hash.hpp
  index.hpp
  mat-arith.hpp
  mat-elem-ops.hpp
  mat-linalg.hpp
  mat-util.hpp
  mutablemat-defs.hpp
  mutablemat-imp.hpp
  mutablemat.hpp
  newdelete.hpp
  queue.hpp
  res-a0-pair.hpp
  ringelem.hpp
  schur-poly-heap.hpp
  smat.hpp
  style.hpp
  f4/f4-types.hpp
  f4/memblock.hpp
  schreyer-resolution/res-memblock.hpp
  schreyer-resolution/res-monomial-types.hpp
  schreyer-resolution/res-schreyer-order.hpp
  )

# these files have .cpp file, but NOT .hpp file
set(CPPONLYFILES
  engine.cpp # TODO: find a new home for the contents
  franzi-gb.cpp
  franzi-interface.cpp
  matrix-kbasis.cpp
  matrix-sort.cpp
  matrix-symm.cpp
  ntl-debugio.cpp
  ntl-internal.cpp
  res-a2-gb.cpp
  ring-vecs.cpp
  interface/aring.cpp
  interface/aring.h
  interface/computation.h # no .cpp yet
  interface/cra.cpp
  interface/cra.h
  interface/factory.cpp
  interface/factory.h
  interface/flint.cpp
  interface/flint.h
  interface/freemodule.cpp # TODO: .h
  interface/gmp-util.h # only has inline definitions
  interface/groebner.cpp
  interface/groebner.h
  interface/matrix.cpp
  interface/matrix.h
  interface/monoid.cpp
  interface/monoid.h
  interface/monomial-ideal.cpp
  interface/monomial-ideal.h
  interface/monomial-ordering.cpp
  interface/monomial-ordering.h
  interface/mutable-matrix.cpp
  interface/mutable-matrix.h
  interface/polyroots.cpp # the declarations are in factory.h
  interface/random.cpp
  interface/random.h
  interface/ring.cpp
  interface/ring.h
  interface/ringelement.cpp
  interface/ringelement.h
  interface/ringmap.cpp
  interface/ringmap.h
  )

# these files all have .hpp and .cpp files
# MES TODO: put these NCAlgebra files (and friends) into alpha order in list
set(SRCLIST
  myalloc
  matrix-ncbasis
  M2FreeAlgebraQuotient
  M2FreeAlgebra
  NCAlgebras/Word
  NCAlgebras/NCReduction
  NCAlgebras/FreeAlgebraQuotient
  NCAlgebras/FreeAlgebra
  NCAlgebras/FreeMonoid
  NCAlgebras/WordTable
  NCAlgebras/SuffixTree
  NCAlgebras/NCGroebner
  NCAlgebras/NCF4
  NCAlgebras/OverlapTable
  NCResolutions/nc-res-computation
  Polynomial
  monomial-collection
  Eschreyer
  GF
  LLL
  NAG # TODO: move raw* functions to e/interface
  SLP
  ZZ
  ZZp
  aring-RRi
  aring-CC
  aring-CCC
  aring-RR
  aring-RRR
  aring-gf-flint-big
  aring-gf-flint
  aring-gf-givaro
  aring-m2-gf
  aring-qq-flint
  aring-qq-gmp
  aring-tower
  aring-zz-flint
  aring-zz-gmp
  aring-zzp-ffpack
  aring-zzp-flint
  aring-zzp
  aring
  assprime
  betti
  buffer
  coeffrings
  comb
  comp-gb-declared
  comp-gb-proxy
  comp-gb
  comp-res
  comp
  cra
  debug
  det
  dmat
  dpoly
  eigen
  finalize
  fplll-interface
  frac
  fractionfreeLU
  franzi-brp
  freemod
  gauss
  gb-default
  gb-homog2
  gb-sugarless
  gb-test1
  gb-toric
  gb-walk
  gbring
  gbweight
  hermite
  hilb
  imonorder
  int-bag
  intarray
  interreduce
  interrupted
  lapack
  localring
  mat
  matrix-con
  matrix-stream
  matrix
  mem
  memory-status
  monideal-minprimes
  monideal
  monoid
  monomial-sets
  monomial
  monsort
  montable
  montableZZ
  mutablecomplex
  ntl-interface
  ntuple
  overflow
  pfaff
  poly
  polyquotient
  polyring
  qring
  reader
  reducedgb-ZZ
  reducedgb-field-local
  reducedgb-field
  reducedgb-marked
  reducedgb
  relem
  res-a0-poly
  res-a0
  res-a1-poly
  res-a1
  res-a2
  ring
  ringmap
  sagbi
  schorder
  schur
  schur2
  schurSn
  skew
  skewpoly
  solvable
  spair
  text-io
  tower # TODO: move rawTowerTranslatePoly to e/interface
  util
  varpower
  weylalg
  # Faugère's F4 Algorithm
  f4/f4-computation
  f4/f4-m2-interface
  f4/f4-mem
  f4/f4-monlookup
  f4/f4-spairs
  f4/f4
  f4/gausser
  f4/hilb-fcn
  f4/monhashtable
  f4/moninfo
  f4/ntuple-monomial
  f4/varpower-monomial
  # Schreyer resolution a la Linear algebra (F4 Faugere style)
  schreyer-resolution/res-f4-computation
  schreyer-resolution/res-f4-m2-interface
  schreyer-resolution/res-f4-monlookup
  schreyer-resolution/res-f4
  schreyer-resolution/res-gausser-QQ-hybrid
  schreyer-resolution/res-gausser-QQ
  schreyer-resolution/res-gausser-ZZp
  schreyer-resolution/res-gausser
  schreyer-resolution/res-moninfo-dense
  schreyer-resolution/res-moninfo-sparse
  schreyer-resolution/res-moninfo
  schreyer-resolution/res-monomial-sorter
  schreyer-resolution/res-poly-ring
  schreyer-resolution/res-schreyer-frame
  schreyer-resolution/res-varpower-monomial
  # Boolean Involutive Gröbner Bases
  bibasis/bibasis
  bibasis/allocator
  bibasis/launcher
  bibasis/monom
  bibasis/monomDL
  bibasis/monomDRL
  bibasis/monomLex
  bibasis/settings-manager
  )

list(TRANSFORM SRCLIST APPEND .cpp OUTPUT_VARIABLE CPPFILES)
list(TRANSFORM SRCLIST APPEND .hpp OUTPUT_VARIABLE HPPFILES)

set(SOURCES ${CPPONLYFILES} ${CPPFILES} ${CFILES})
set(HEADERS ${HPPONLYFILES} ${HPPFILES} ${HFILES})
list(APPEND HEADERS ${CMAKE_BINARY_DIR}/include/M2/config.h)

###############################################################################
## Generate TAGS file
# TODO: the order is somewhat different, is it a problem?

if(ETAGS)
  set(TAGS TAGS)
  set_source_files_properties(TAGS PROPERTIES GENERATED true)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/TAGS
    COMMENT "Generating e/TAGS file"
    COMMAND ${ETAGS} -o TAGS ${HEADERS} ${SOURCES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

###############################################################################
## Compile the engine
# TODO: enable INTERPROCEDURAL_OPTIMIZATION?

# TODO: remove STATIC once M2-engine can be used independently, then we can
# set -DBUILD_SHARED_LIBS=ON to generate a shared library
add_library(M2-engine STATIC ${SOURCES} ${HEADERS} ${TAGS})

# TODO: Which headers should be included in the development build?
set_target_properties(M2-engine PROPERTIES PUBLIC_HEADER "${HEADERS}")

target_include_directories(M2-engine PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include/Macaulay2>)

# TODO: make engine independent of interpreter headers
target_link_libraries(M2-engine PUBLIC M2-interpreter memtailor mathic mathicgb)

if(EIGEN3_FOUND)
  target_link_libraries(M2-engine PUBLIC Eigen3::Eigen)
endif()

if(OpenMP_FOUND)
  target_link_libraries(M2-engine PUBLIC OpenMP::OpenMP_CXX)
endif()

# Compiler warning flags
target_compile_options(M2-engine PRIVATE
  -Wno-cast-qual # FIXME
  -Wno-sign-compare
  -Wno-unused-local-typedefs # FIXME: caused by mathic/Geobucket.h:510:49

  $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:
  -Wno-deprecated-register # caused by mps/mpc.h:114:37
  -Wno-mismatched-tags # FIXME: caused by scc1
  -Wno-unused-variable # FIXME: caused by schur2.cpp:597:31
  >

  $<$<COMPILE_LANG_AND_ID:CXX,GNU>:
  -Wno-deprecated-copy -Wno-unknown-pragmas # caused by Givaro and fflas_ffpack
  -Wno-ignored-qualifiers # FIXME: caused by bibasis/tset.hpp:44:9
  -Wno-implicit-fallthrough # FIXME: caused by gb-default.cpp, gb-test1.cpp, gb-walk.cpp, hermite.cpp, etc.
  >

  # Intel TODO: -diag-disable 981,869,383,2259,444 -debug -Wimplicit-function-declaration
  )

###############################################################################
## Export the target

# TODO: change ARCHIVE to LIBRARY once M2-engine can be used independently
install(TARGETS M2-engine mathicgb mathic memtailor EXPORT Macaulay2
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}/Macaulay2/lib
  COMPONENT devel EXCLUDE_FROM_ALL
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/Macaulay2
  COMPONENT devel EXCLUDE_FROM_ALL)

###############################################################################
## Add source linting and formatting checks for this target, see cmake/prechecks.cmake

if(LINTING)
  _ADD_PRECHECKS(M2-engine "${CFILES}" "${HPPONLYFILES} ${CPPONLYFILES} ${HPPFILES} ${CPPFILES}")
endif()

_ADD_CLANG_FORMAT(M2-engine "${CFILES}" "${HPPONLYFILES} ${CPPONLYFILES} ${HPPFILES} ${CPPFILES}")

###############################################################################
## To try, run ctest or ./M2-unit-tests in Macaulay2/e

if(BUILD_TESTING)
  include(GoogleTest)

  # TODO: overflow tests
  # TODO: break up into multiple branches
  add_executable(M2-unit-tests
    unit-tests/M2-cpp-replacement.cpp
    unit-tests/M2-replacement.c
    unit-tests/M2mem-replacement.c
    unit-tests/M2mem-replacement.h

    unit-tests/ARingTest.hpp
    unit-tests/ARingZZTest.cpp
    unit-tests/ARingZZpTest.cpp
    unit-tests/ARingGFTest.cpp # FIXME: see aring-gf-givaro.cpp:199
    unit-tests/ARingQQFlintTest.cpp
    unit-tests/ARingQQGmpTest.cpp
    unit-tests/ARingRRTest.cpp
    unit-tests/ARingCCTest.cpp
    unit-tests/ARingRRRTest.cpp
    unit-tests/ARingCCCTest.cpp
    unit-tests/NCGroebnerTest.cpp

    unit-tests/RingTest.hpp
    unit-tests/RingZZTest.cpp
    unit-tests/RingZZpTest.cpp
    unit-tests/RingQQTest.cpp
    unit-tests/RingCCCTest.cpp
    unit-tests/RingRRRTest.cpp
    unit-tests/RingTowerTest.cpp

    unit-tests/DMatTest.hpp
    unit-tests/DMatZZpTest.cpp

    unit-tests/ResTest.cpp
    unit-tests/PointArray.cpp
    unit-tests/SubsetTest.cpp
    unit-tests/basics-test.cpp

    unit-tests/fromStream.cpp
    unit-tests/testMain.cpp # not needed, except for GC_INIT
    )

  if(BDWGC_FOUND)
  target_link_libraries(M2-unit-tests M2-engine ${BDWGC_LIBRARIES} ${CMAKE_DL_LIB})
  endif()

  ## Add the tests
  # TODO: valgrind --track-origins=yes ...
  gtest_discover_tests(M2-unit-tests TEST_PREFIX unit-tests:)

  ## Link with Googletest
  if(GTEST_FOUND)
  target_link_libraries(M2-unit-tests GTest::GTest GTest::Main)
  endif()

  target_compile_options(M2-unit-tests PRIVATE
    -Wno-cast-qual # FIXME: caused by NAG.hpp:559:37 and NAG.hpp:603:37
    -Wno-sign-compare
    $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-mismatched-tags> # FIXME
    )

  ###############################################################################
  ## GivaroTest.cpp has a main function and does not use gtest
  #add_executable(M2-unit-tests-givaro unit-tests/GivaroTest.cpp) # FIXME: line 155
  #target_link_libraries(M2-unit-tests-givaro M2-engine)

=== Macaulay2/editors/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for generating grammar files for editors
## and syntax highlighting engines as well as the M2-mode package for Emacs.
## - M2-editors generates grammar files
## - M2-emacs   generates the M2-mode package for Emacs
## - M2-highlightjs   generates syntax highlighting library for javascript

# TODO: generate vim grammar
# TODO: generate textmate grammar

set(M2 ${M2_DIST_PREFIX}/${M2_INSTALL_BINDIR}/M2)
set(M2_ARGS --script)

###############################################################################
## Generating the grammar files is mainly done in make-M2-symbols.m2.
## To add to the M2-editors target, add grammar filenames here and in .gitignore.
set(GRAMMAR_FILES
  atom/macaulay2.cson
  highlightjs/macaulay2.js
  prism/macaulay2.js
  pygments/macaulay2.py
#  rouge/macaulay2.rb
  vim/m2.vim.syntax
  vim/m2.vim.dict
  emacs/M2-symbols.el)

set(GRAMMAR_TEMPLATES ${GRAMMAR_FILES})
list(TRANSFORM GRAMMAR_TEMPLATES APPEND ".in")
add_custom_target(M2-editors DEPENDS ${GRAMMAR_FILES})
add_custom_command(OUTPUT ${GRAMMAR_FILES}
  COMMENT "Generating M2 grammar files for editors"
  COMMAND ${M2} ${M2_ARGS} ${CMAKE_CURRENT_SOURCE_DIR}/make-M2-symbols.m2
  MAIN_DEPENDENCY make-M2-symbols.m2
  DEPENDS M2-core ${GRAMMAR_TEMPLATES})

###############################################################################
## Generating the M2-mode package for Emacs

if(NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/emacs/make-M2-emacs-help.m2)
  message(WARNING "Macaulay2/editors/emacs submodule is missing; skipping M2-emacs target")
  return()
endif()

# TODO: only the emacs target is installed in usr-dist by default
set(M2_INSTALL_EMACSDIR
  ${M2_DIST_PREFIX}/${M2_INSTALL_DATAROOTDIR}/emacs/site-lisp/macaulay2)
file(COPY emacs/ DESTINATION ${M2_INSTALL_EMACSDIR}
  FILES_MATCHING PATTERN "M2*" PATTERN "*.in" EXCLUDE)

set(EMACS_FILES M2-emacs-help.txt M2-emacs.m2 M2-symbols.el.gz)
list(TRANSFORM EMACS_FILES PREPEND ${M2_INSTALL_EMACSDIR}/)
add_custom_target(M2-emacs ALL DEPENDS ${EMACS_FILES})
add_custom_command(OUTPUT ${EMACS_FILES}
  COMMENT "Generating Emacs package"
  COMMAND ${M2} ${M2_ARGS} ${CMAKE_CURRENT_SOURCE_DIR}/emacs/make-M2-emacs-help.m2
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/emacs/M2-symbols.el ${M2_INSTALL_EMACSDIR}
  COMMAND gzip -nf9 M2-symbols.el
  # This command updates the generated content in the M2-emacs submodule
  COMMAND ${CMAKE_COMMAND} -E copy M2-emacs-help.txt M2-emacs.m2 M2-symbols.el.gz ${CMAKE_CURRENT_SOURCE_DIR}/emacs
  MAIN_DEPENDENCY emacs/make-M2-emacs-help.m2
  WORKING_DIRECTORY ${M2_INSTALL_EMACSDIR}
  DEPENDS emacs/M2-symbols.el make-M2-symbols.m2)

################################################################################
## Generating highlight.js for syntax highlighting in the html documentation

if(NOT NPM)
  message(WARNING "npm is missing; html docs will not have syntax highlighting")
  file(TOUCH highlightjs/highlight.js)
  return()
endif()

set(HIGHLIGHTJS_DIR ${CMAKE_CURRENT_BINARY_DIR}/highlightjs)
file(MAKE_DIRECTORY HIGHLIGHTJS_DIR)
file(COPY highlightjs/ DESTINATION ${HIGHLIGHTJS_DIR}
  FILES_MATCHING PATTERN "*.json" PATTERN "*.js" PATTERN "*.css")

add_custom_target(M2-highlightjs ALL DEPENDS highlightjs/highlight.js)
add_custom_command(OUTPUT highlightjs/highlight.js
  COMMENT "Generating highlight.js syntax file"
  COMMAND ${NPM} install && ${NPM} run build
  WORKING_DIRECTORY ${HIGHLIGHTJS_DIR}
  DEPENDS highlightjs/macaulay2.js)

=== Macaulay2/packages/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for installing and checking the packages.
## - set options via the cmake command line:
##     RerunExamples=true cmake .
## - targets:
##     cmake --build . --target {install,check,all,uninstall}-{packages,PACKAGE}
## - running tests in parallel:
##     ctest -R check-PACKAGE -j4

include(latex) ## CMake script for creating PDF documentation

## Macro for configuring M2 commands so they can be run as M2 -e ${STR}
# _template_var:  variable holding the string template
# _string_var:    return variable (optional, default: _template_var)
# _one_line:      whether to remove newlines and extra space
MACRO (_M2_STRING_CONFIGURE _template_var) # optional: _string_var _one_line
  if(NOT "${ARGV1}" STREQUAL "")
    set(_string_var ${ARGV1})
  else()
    set(_string_var ${_template_var})
  endif()
  string(CONFIGURE "${${_template_var}}" ${_string_var})
  if("${ARGV2}")
    string(REGEX REPLACE "(\n *| +)" " " ${_string_var} "${${_string_var}}")
  endif()
ENDMACRO ()

#################################################################################
## Package options
## The default is to install all distributed packages
set(PACKAGES "${DISTRIBUTED_PACKAGES}" CACHE INTERNAL "the list of packages to install")
set(PACKAGES_DEVEL       "EngineTests" CACHE INTERNAL "the list of packages to only check")
## Arguments to M2
set(errorDepth                  "3" CACHE STRING "set the error printing depth")
set(debugLevel                  "0" CACHE STRING "set the debugging level")
set(gbTrace                     "0" CACHE STRING "set the Groebner basis trace level")
## Options to installPackage
set(CheckDocumentation       "true" CACHE STRING "check documentation for completeness")
set(IgnoreExampleErrors     "false" CACHE STRING "ignore errors in example code")
set(RemakeAllDocumentation  "false" CACHE STRING "remake all documentation")
set(RerunExamples           "false" CACHE STRING "rerun example outpuat files")
## Arguments to the M2 subprocess that runs individual tests and examples; see runFile in m2/run.m2
set(ArgumentMode "InvertArgs|SetOutputFile|SetCaptureErr|NoCapture" # |ArgNoThreads for --no-threads
  CACHE INTERNAL "bitmask for ctest check arguments")

# Allow arguments above to be set via environment variables
foreach(_var in ITEMS PACKAGES PACKAGES_DEVEL errorDepth debugLevel gbTrace
    CheckDocumentation IgnoreExampleErrors RemakeAllDocumentation RerunExamples ArgumentMode)
  if(DEFINED ENV{${_var}})
    message("## Set via environment:   ${_var}\t= $ENV{${_var}} (default: ${${_var}})")
    set(${_var} "$ENV{${_var}}")
  endif()
endforeach()

# Make sure PACKAGES is a list
string(REPLACE " " ";" PACKAGES "${PACKAGES}")

#################################################################################
## M2 arguments and commands that will be passed to M2 -e ${STR}
set(M2 ${M2_DIST_PREFIX}/${M2_INSTALL_BINDIR}/M2)
set(M2_ARGS -q --stop --silent --no-preload --no-threads -e errorDepth=${errorDepth} -e debugLevel=${debugLevel})
set(M2_INSTALL_TEMPLATE [[installPackage("@package@",
  Verbose                => $<IF:$<BOOL:${VERBOSE}>,true,false>,
  RerunExamples          => ${RerunExamples},
  CheckDocumentation     => ${CheckDocumentation},
  IgnoreExampleErrors    => ${IgnoreExampleErrors},
  RemakeAllDocumentation => ${RemakeAllDocumentation},
  InstallPrefix          => "${M2_DIST_PREFIX}/",
  UserMode               => false,
  SeparateExec           => true,
  DebuggingMode          => true)]])
set(M2_NEED_TEMPLATE    [[needsPackage("@package@", LoadDocumentation=>true, DebuggingMode=>true)]])
set(M2_TEST_TEMPLATE    [[debug Core \; argumentMode = @ArgumentMode@ \; check(@_i@, "@package@")]])
set(M2_INFO_TEMPLATE    [["info-"|"@package@" << @package@#"test number" << close]]) # ignore the color
set(M2_CHECK_TEMPLATE   [[check("@package@", UserMode=>false, Verbose=>$<IF:$<BOOL:${VERBOSE}>,true,false>)]])

# TODO: simplify
set(M2_DOC_TEMPLATE [[installPackage("@package@",
  Verbose                => $<IF:$<BOOL:${VERBOSE}>,true,false>,
  RerunExamples          => ${RerunExamples},
  CheckDocumentation     => ${CheckDocumentation},
  IgnoreExampleErrors    => ${IgnoreExampleErrors},
  RemakeAllDocumentation => ${RemakeAllDocumentation},
  InstallPrefix          => "${M2_DIST_PREFIX}/",
  UserMode               => false,
  SeparateExec           => true,
  DebuggingMode          => true,
  MakeHTML               => false,
  MakeInfo               => false,
  MakePDF                => true)]])

#################################################################################
## Declare all targets: {install,check,all,uninstall}-{packages,PACKAGE}

add_custom_target(list-packages
  COMMENT "Listing available packages"
  COMMAND ${CMAKE_COMMAND} -E echo ${DISTRIBUTED_PACKAGES})

# Prefixes for package targets
set(_target_prefixes "install;info;doc;check;all;uninstall")
# Package targets that should be included in ALL
set(_all_target_list "")

if(BUILD_DOCS)
  list(APPEND _all_target_list "install-packages")
endif()

if(BUILD_TESTING)
  list(APPEND _all_target_list "info-packages")
endif()

foreach(_target IN LISTS _target_prefixes)
  string(TOUPPER "${_target}_TARGETS" _dependencies_list)
  ## eg: ${_target}-Style ${_target}-Macaulay2Doc ...
  list(TRANSFORM PACKAGES PREPEND "${_target}-" OUTPUT_VARIABLE ${_dependencies_list})
  ## Add individual dependencies to the main target
  add_custom_target(${_target}-packages DEPENDS ${${_dependencies_list}})
endforeach()

set_target_properties(${_all_target_list} PROPERTIES EXCLUDE_FROM_ALL OFF)

#################################################################################
## Handling special dependencies

# 1. all packages depend on Macaulay2Doc and Macaulay2Doc depends on Style
# TODO: reduce dependencies, or move Macaulay2Doc and Style to Core
# See https://github.com/Macaulay2/M2/issues/1085
set(Macaulay2Doc_dependencies
  ${M2_DIST_PREFIX}/${M2_INSTALL_LIBDIR}/Macaulay2/FirstPackage/.installed
  ${M2_DIST_PREFIX}/${M2_INSTALL_LIBDIR}/Macaulay2/Style/.installed)
set(_default_dependencies
  ${M2_DIST_PREFIX}/${M2_INSTALL_LIBDIR}/Macaulay2/Macaulay2Doc/.installed)
set(EngineTests_dependencies ${_default_dependencies})
set(Style_dependencies
  ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR}/Style/highlight.js)

add_custom_command(
  OUTPUT ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR}/Style/highlight.js
  COMMAND ${CMAKE_COMMAND} -E copy
    ${CMAKE_CURRENT_BINARY_DIR}/../editors/highlightjs/highlight.js
    ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR}/Style
  DEPENDS M2-highlightjs)

# TODO: automate this process
# 2. FourTiTwo needs 4ti2
# 3. CohomCalg needs cohomcalg
# 4. gfanInterface and StatePolytope need gfan
# 5. Polyhedra needs lrslib
# 6. SemidefiniteProgramming needs csdp
# 7. Normaliz needs normaliz
# 8. Nauty and NautyGraphs need nauty
# 9. Topcom needs topcom
# 10. Polymake and PolymakeInterface need polymake

#################################################################################

foreach(package IN LISTS PACKAGES)
  ## Make a list of package sources to detect changes
  file(GLOB_RECURSE ${package}_sources RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${package}.m2 ${package}/*)

  ## Copy package and auxiliary folder to usr-dist
  file(COPY ${package}.m2 DESTINATION ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR})
  if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${package})
    file(COPY ${package}  DESTINATION ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR})
  endif()

  ## Configuring the command strings
  _M2_STRING_CONFIGURE(M2_INSTALL_TEMPLATE M2_INSTALL_STRING TRUE)
  _M2_STRING_CONFIGURE(M2_CHECK_TEMPLATE   M2_CHECK_STRING)
  _M2_STRING_CONFIGURE(M2_NEED_TEMPLATE    M2_NEED_STRING)
  _M2_STRING_CONFIGURE(M2_INFO_TEMPLATE    M2_INFO_STRING)
  _M2_STRING_CONFIGURE(M2_DOC_TEMPLATE     M2_DOC_STRING TRUE)

  ###############################################################################
  ## Enable USES_TERMINAL only for Macaulay2Doc and EngineTests
  ## Also make all other packages depend on Macaulay2Doc and Style
  if(package MATCHES "(Style|FirstPackage|Macaulay2Doc)" OR package IN_LIST PACKAGES_DEVEL)
    set(USES_TERMINAL USES_TERMINAL)
  else()
    unset(USES_TERMINAL)
    foreach(_dep IN LISTS _default_dependencies)
      if(TARGET ${_dep})
	list(APPEND ${package}_dependencies ${_dep})
      elseif(NOT EXISTS ${_dep})
	list(APPEND ${package}_dependencies ${_dep})
      endif()
    endforeach()
  endif()

  ## TODO: remove this; see https://github.com/Macaulay2/M2/pull/1483
  if(package MATCHES "(ThreadedGB)")
    set(USES_TERMINAL USES_TERMINAL)
  endif()

  ## Custom command for getting package information
  # TODO: currently only number of tests is stored, but we can do more
  add_custom_command(OUTPUT info-${package}
    COMMENT "Getting package information for ${package}"
    COMMAND ${M2} ${M2_ARGS} -e ${M2_NEED_STRING} -e ${M2_INFO_STRING} -e "exit 0"
    VERBATIM
    DEPENDS M2-core ${${package}_sources}
    )

  ## Custom target for installing the package
  add_custom_target(install-${package}
    COMMENT "Installing package ${package}"
    COMMAND ${M2} ${M2_ARGS} -e ${M2_INSTALL_STRING} -e ${M2_INFO_STRING} -e "exit 0"
    COMMAND gzip -nf9 ${M2_DIST_PREFIX}/${M2_INSTALL_INFODIR}/${package}.info
    VERBATIM
    ${USES_TERMINAL}
    DEPENDS M2-core ${${package}_dependencies}
    BYPRODUCTS ${M2_DIST_PREFIX}/${M2_INSTALL_LIBDIR}/Macaulay2/${package}/.installed
    )

  ## Custom target for generating PDF documentation for the package
  # TODO: put the individual package's version in the name
  # NOTE: has to remain in sync with installPDF in m2/book.m2
  set(_bookname manual)
  set(_bookdir  ${M2_DIST_PREFIX}/${M2_INSTALL_DOCDIR}/${package})
  _ADD_LATEX_TARGET(${package} ${_bookdir} ${_bookname})
  add_custom_target(doc-${package} DEPENDS ${_bookdir}/${_bookname}.pdf)

  ## Custom target for uninstalling the package
  add_custom_target(uninstall-${package}
    COMMENT "Uninstalling package ${package}"
    COMMAND
      rm -rf info-${package}
        ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR}/${package}*
        ${M2_DIST_PREFIX}/${M2_INSTALL_LIBDIR}/Macaulay2/${package}*
        ${M2_DIST_PREFIX}/${M2_INSTALL_DOCDIR}/${package}*
        ${M2_DIST_PREFIX}/${M2_INSTALL_INFODIR}/${package}*
    )

  ###############################################################################

  # FIXME: what is if ! grep "CacheExampleOutput => true" @srcdir@/$i.m2 ?
  ## Custom target for checking the package
  add_custom_target(check-${package}
    COMMENT "Checking package ${package}"
    COMMAND ${M2} ${M2_ARGS} -e ${M2_CHECK_STRING} -e ${M2_INFO_STRING} -e "exit 0"
    VERBATIM
    ${USES_TERMINAL}
    DEPENDS M2-core
    )

  # TODO: call a script to do this in build step of info-${package}?
  if(BUILD_TESTING)
    ## Read the number of tests
    if(EXISTS ${CMAKE_CURRENT_BINARY_DIR}/info-${package})
      file(READ ${CMAKE_CURRENT_BINARY_DIR}/info-${package} ${package}-testcount)
    else()
      set(${package}-testcount 0)
    endif()
    if(NOT ${package}-testcount MATCHES "^[0-9]+$")
      set(${package}-testcount 0)
    endif()
    ## Add individual tests for package
    foreach(_i RANGE ${${package}-testcount})
      if(${_i} LESS ${${package}-testcount})
	_M2_STRING_CONFIGURE(M2_TEST_TEMPLATE M2_TEST_STRING)
        add_test(NAME "check-${package}-${_i}"
          COMMAND ${M2} ${M2_ARGS} -e ${M2_TEST_STRING} -e "exit 0"
          )
      endif()
    endforeach()
  endif()

  ###############################################################################

  ## Everything bagel
  add_custom_target(all-${package}
    COMMENT "Installing and checking package ${package}"
    COMMAND ${M2} ${M2_ARGS} -e ${M2_INSTALL_STRING} -e ${M2_INFO_STRING} -e ${M2_CHECK_STRING} -e "exit 0"
    VERBATIM
    ${USES_TERMINAL}
    DEPENDS M2-core
    )
endforeach()

=== Macaulay2/tests/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for adding various tests to CTest.
##
## - list tests:      ctest -N
## - build and test:  ctest --build-and-test
## - rerun matching tests:
##     ctest -R schorder --rerun-failed -V
##
## See https://gitlab.kitware.com/cmake/community/-/wikis/doc/ctest/Testing-With-CTest

# TODO: some targets have different resource limits
set(SUBDIRS normal slow gigantic goals quarantine engine threads)

add_custom_target(M2-tests)
add_dependencies(M2-tests M2-tests-ComputationsBook) # M2-tests-rationality

###############################################################################
## Default resource limits
# TODO: add memory, virtual memory, and stack size
# the tests aren't run through bash, so ulimit wouldn't work
if(DEBUG)
  set(CTEST_TEST_TIMEOUT 1400)
  #MLIMIT ?= 1200000
  #VLIMIT ?= 2000000
else()
  set(CTEST_TEST_TIMEOUT 900)
  ## one test doesn't work with only 150MB RAM, ext-total.m2, on a 64 bit intel machine:
  #MLIMIT ?=  800000
  #VLIMIT ?= 2000000
endif()
## make the stack limit always the same as it would be under MacOS
#SLIMIT ?= 8192

###############################################################################
## M2 arguments and commands that will be passed to M2 -e ${STR}
set(GC_MAXIMUM_HEAP_SIZE 400M CACHE STRING "maximum collected heap size")
set(M2 ${M2_DIST_PREFIX}/${M2_INSTALL_BINDIR}/M2)
# gbTrace, errorDepth, and debugLevel are set in packages/CMakeLists.txt
set(M2_ARGS
  -q --stop --silent --no-debug --no-randomize # --no-prompts --no-...
  -e errorDepth=${errorDepth} -e debugLevel=${debugLevel} -e gbTrace=${gbTrace})
set(M2_PATH "join(path,{\"${CMAKE_CURRENT_SOURCE_DIR}/\",\"${CMAKE_SOURCE_DIR}/packages/\"})")
# Read the file, then exit. Note: a "restart" command causes the test to not halt
set(M2_TEST_TEMPLATE [[input("@CMAKE_CURRENT_SOURCE_DIR@/@_group@/@_testfile@")]])

# Allow GC_MAXIMUM_HEAP_SIZE to be set via environment variable
foreach(_var in ITEMS GC_MAXIMUM_HEAP_SIZE)
  if(DEFINED ENV{${_var}})
    message("## Set via environment:   ${_var}\t= $ENV{${_var$}} (default: ${${_var}})")
    set(${_var} "$ENV{${_var}}")
  endif()
endforeach()

## Regular expressions for various test errors
## TODO: add WILL_FAIL tests
set(M2_FAIL_REGEX
  [[internal error;non-zero status;assertion failed]]
  "--back trace--"
  "\nCommand terminated;\nGC;\n0x;\nout of mem"
  "user.*system.*elapsed;\n[0-9]+\.[0-9]+user"
  [[\.m2:[0-9][0-9]*:[0-9][0-9]*:\([0-9][0-9]*\):]] # TODO: this one catches commented errors
  )

###############################################################################
## Adding tests for all subdirectories

foreach(_group IN LISTS SUBDIRS)

  ## eg: LU.m2 ...
  file(GLOB ${_group}_TESTS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/${_group} "${_group}/*.m2")

  foreach(_testfile IN LISTS ${_group}_TESTS)
    ## ctest target for testing the package
    set(_testname ${_group}/${_testfile})

    ## configure the test string
    string(CONFIGURE "${M2_TEST_TEMPLATE}" M2_TEST_STRING)

    add_test(NAME ${_testname}
      COMMAND ${M2} ${M2_ARGS} -e path=${M2_PATH} -e ${M2_TEST_STRING} -e "exit 0"
      WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR}/${_group}
      )

    set_tests_properties(${_testname} PROPERTIES
      FAIL_REGULAR_EXPRESSION "${M2_FAIL_REGEX}"
      ENVIRONMENT "GC_MAXIMUM_HEAP_SIZE=${GC_MAXIMUM_HEAP_SIZE}"
      TIMEOUT ${CTEST_TEST_TIMEOUT} # TODO: this shouldn't be necessary
      )
  endforeach()

endforeach()

###############################################################################
## ComputationsBook targets:
# - M2-tests-ComputationsBook-${_chapter}
# - M2-tests-ComputationsBook-${_chapter}-changes
# - M2-tests-ComputationsBook-${_chapter}-diff
# Tests:
# - ComputationsBook/${_chapter}

add_custom_target(M2-tests-ComputationsBook)

set(CHAPTERS completeIntersections constructions d-modules exterior-algebra geometry
  monomialIdeals preface programming schemes solving toricHilbertScheme varieties)

set(M2_ARGS -q --stop --print-width 0)

foreach(_chapter IN LISTS CHAPTERS)

  ## configure the test string
  set(_testfile test.m2)
  set(_group ComputationsBook/${_chapter})

  set(book_patterns    ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/../patterns)
  set(chapter_patterns ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/patterns)

  string(CONFIGURE "${M2_TEST_TEMPLATE}" M2_TEST_STRING)
  set(M2_PATH "join({\"${CMAKE_CURRENT_BINARY_DIR}/${_group}\",\"${CMAKE_CURRENT_SOURCE_DIR}/${_group}\"},path)")

  if(NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/${_group})
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group})
  endif()

  ###############################################################################
  # we depend on "diff" accepting some options that perhaps only GNU diff does
  add_custom_target(M2-tests-ComputationsBook-${_chapter}
    COMMAND ${M2} ${M2_ARGS} -e path=${M2_PATH} -e ${M2_TEST_STRING} -e "exit 0" > test.out
    COMMAND sed -f ${book_patterns} -f ${chapter_patterns} > test.out.trim < test.out
    COMMAND sed -f ${book_patterns} -f ${chapter_patterns} > test.out.expected.trim
      < ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/test.out.expected
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    VERBATIM
    )
  add_custom_target(M2-tests-ComputationsBook-${_chapter}-diff
    COMMAND diff -B -b -u test.out.expected.trim test.out.trim
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    DEPENDS M2-tests-ComputationsBook-${_chapter}
    VERBATIM
    )
  add_custom_target(M2-tests-ComputationsBook-${_chapter}-changes
    COMMAND diff -u chapter.m2 test.m2 || true
    COMMAND diff -u chapter.out.expected test.out.expected || true
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${_group}
    VERBATIM
    )

  add_dependencies(M2-tests-ComputationsBook M2-tests-ComputationsBook-${_chapter})

  ###############################################################################
  add_test(NAME ${_group}
    COMMAND diff -B -b -u
      ${CMAKE_CURRENT_BINARY_DIR}/${_group}/test.out.expected.trim
      ${CMAKE_CURRENT_BINARY_DIR}/${_group}/test.out.trim
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    )

  # TODO: capture output from the chapter's code with M2 version 0.9.2 as a standard of comparison.
  # this requires an old binary, but we run it only once and save the output
  #set(OLDM2 M2-0.9.2)
  #set(OLDM2CMD ${LIMIT} time nice -18 ${OLDM2} -s -q -e${PATHJOIN})
  #add_custom_command(OUTPUT test.oldout test.oldvalues
  #  COMMAND ${OLDM2CMD} -e'load "$(chapter_srcdir)/../capture.m2"; input "$<"; exit 0'  >test.oldout.tmp </dev/null
  #  COMMAND mv test.oldout.tmp test.oldout
  #  DEPENDS chapter.m2 ../capture.m2
  #  )
  #add_custom_target(ComputationsBook-capture
  #  DEPENDS test.oldout test.oldvalues
  #  )

endforeach()

# install normal tests for "check Core"
file(MAKE_DIRECTORY ${M2_DIST_PREFIX}/${M2_INSTALL_DOCDIR}/Core/tests)
file(GLOB CORE_TESTS "${CMAKE_CURRENT_SOURCE_DIR}/normal/*.m2")
foreach(CORE_TEST ${CORE_TESTS})
  file(COPY ${CORE_TEST} DESTINATION ${M2_DIST_PREFIX}/${M2_INSTALL_DOCDIR}/Core/tests/)
endforeach()

# TODO: add_subdirectory(rationality)

=== debian/changelog ===
macaulay2 (1.21+ds-3) unstable; urgency=medium

  * debian/control
    - Bump Standards-Version to 4.6.2.
  * debian/macaulay2-common.linktrees
    - Go back to providing paths to specific KaTeX files in "contrib"
      folder; the documentation is expecting ".min.js", but the Debian
      package has only ".js".
  * debian/patches/skip-failing-package-tests.patch
    - Skip Topcom and Triangulations tests that are mysteriously failing
      during Ubuntu autopkgtests.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 31 Dec 2022 10:43:00 -0500

macaulay2 (1.21+ds-2) unstable; urgency=medium

  * debian/copyright
    - Add license info for GMP <-> Python integer conversion routines from
      gmpy2 used by Python package.
    - Add license info for JSON parsing tests.
  * debian/patches/topcom-memopt.patch
    - New patch; use --memopt option when calling TOPCOM to save memory and
      avoid example/test failures.
  * debian/rules
    - Update comment about cached examples.
    - Add -latomics to LIBS on armel to fix TBB linking issue.
  * debian/tests/control
    - Add libmpfi-dev to Depends for package tests; it is needed for a
      ForeignFunctions test.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 16 Dec 2022 06:07:27 -0500

macaulay2 (1.21+ds-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Add libffi-dev to Build-Depends; needed for new ForeignFunctions
      package.
  * debian/copyright
    - Add license information for new packages.
  * debian/macaulay2-common.lintian-overrides
    - Update package-contains-documentation-outside-usr-share-doc paths.
  * debian/patches/customize-argument-mode.patch
    - Remove patch; applied upstream.
  * debian/patches/libatomic.patch
    - Remove patch; issue fixed in tbb package.
  * debian/patches/skip-failing-core-tests.patch
    - Remove timing-quotient patch; applied upstream.
  * debian/patches/skip-failing-package-tests.patch
    - Restore Topcom tests; they were only failing occassionally and we'd
      like to make sure they run with the most recent version of TOPCOM.
    - Remove VersalDeformations patch; this test was commented out
      upstream.
    - Skip some AssociativeAlgebras and MinimalPrimes tests that have been
      failing.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 14 Dec 2022 19:54:09 -0500

=== debian/control ===
Source: macaulay2
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: 4ti2,
               bison,
               cohomcalg,
               coinor-csdp,
               debhelper-compat (= 13),
               dh-linktree,
               fflas-ffpack,
               flex,
               gfan,
               install-info,
               libatomic-ops-dev,
               libboost-dev,
               libboost-math-dev,
               libboost-regex-dev,
               libboost-stacktrace-dev,
               libcdd-dev,
               libeigen3-dev,
               libffi-dev,
               libflint-dev (>= 2.6.0~),
               libfrobby-dev,
               libgc-dev,
               libgdbm-dev,
               libgivaro-dev,
               libglpk-dev,
               libgtest-dev,
               liblapack-dev,
               liblzma-dev,
               libmathic-dev,
               libmathicgb-dev (>= 1.0~git20220225~),
               libmemtailor-dev,
               libmpfi-dev,
               libmpfr-dev,
               libmps-dev,
               libntl-dev,
               libreadline-dev,
               libsingular4-dev (>= 1:4.2.0~),
               libtbb-dev,
               libxml2-dev,
               lrslib,
               lsb-release,
               nauty,
               normaliz,
               pkg-config,
               python3-dev <!nopython>,
               singular-data,
               time,
               topcom
Build-Depends-Indep: dh-sequence-elpa,
                     faketime,
                     fonts-glyphicons-halflings,
                     fonts-katex,
                     gdbmtool,
                     jdupes,
                     libjs-bootsidemenu,
                     libjs-bootstrap,
                     libjs-d3,
                     libjs-jquery (>= 3.5.1+dfsg+~3.5.5-4),
                     libjs-katex (>= 0.11.0~),
                     libjs-nouislider,
                     libjs-three,
                     libjs-underscore,
                     node-clipboard,
                     node-css-loader <!nodoc>,
                     node-highlight.js <!nodoc>,
                     node-import-local <!nodoc>,
                     node-interpret <!nodoc>,
                     node-rechoir <!nodoc>,
                     node-style-loader <!nodoc>,
                     npm <!nodoc>,
                     pkg-js-tools <!nodoc>,
                     w3c-markup-validator <!nodoc>,
                     webpack <!nodoc>
Standards-Version: 4.6.2
Homepage: http://macaulay2.com
Vcs-Browser: https://salsa.debian.org/math-team/macaulay2
Vcs-Git: https://salsa.debian.org/math-team/macaulay2.git
Rules-Requires-Root: no

Package: macaulay2
Architecture: any
Depends: gdbmtool,
         macaulay2-common (= ${source:Version}),
         singular-data,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: 4ti2,
            cohomcalg,
            coinor-csdp,
            elpa-macaulay2 (= ${source:Version}),
            gfan,
            info,
            lrslib,
            nauty,
            normaliz,
            texlive-latex-base,
            topcom,
            www-browser,
            xdg-utils,
            xterm
Suggests: bergman,
          dot2tex,
          fig2dev,
          graphviz,
          pdf-viewer,
          phcpack,
          polymake,
          qepcad,
          sdpa
Description: Software system for algebraic geometry research
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the architecture dependent portion of Macaulay2.

Package: macaulay2-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Software system for algebraic geometry research (common files)
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the architecture independent portion of Macaulay2, and is
 normally installed automatically when one of the architecture dependent
 packages is installed.

Package: elpa-macaulay2
Architecture: all
Multi-Arch: foreign
Section: editors
Depends: ${elpa:Depends}, ${misc:Depends}
Recommends: emacs
Description: Software system for algebraic geometry research (Emacs package)
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the modes for running Macaulay2 within Emacs and
 editing Macaulay2 code.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk # for SOURCE_DATE_EPOCH

export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=-lto

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE=1
endif

# needed for reproducible-version.patch
export CURDIR

VERSION := $(shell cat M2/VERSION)

%:
	dh $@ --sourcedirectory=M2 --with linktree

# use exec_prefix instead of prefix in libdir, as that's what's needed
# to properly substitute paths in Layout#2
LIBDIR := \$${exec_prefix}/lib/$(DEB_HOST_MULTIARCH)

# set emacs lisp file installation directory so that the documentation
# matches where dh_elpa installs them
EMACSDIR := \
	\$${prefix}/share/emacs/site-lisp/elpa/macaulay2-$(VERSION)

# fix TBB linking issue on armel (https://github.com/Macaulay2/M2/pull/2528)
ifeq ($(DEB_HOST_ARCH),armel)
	LIBS = -latomic
endif

WITH_PYTHON := $(if $(filter nopython, $(DEB_BUILD_PROFILES)),, --with-python)

ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DISABLE_DOCUMENTATION = --disable-documentation
else
DISABLE_DOCUMENTATION := $(if $(shell dh_listpackages -i),,\
	--disable-documentation)
endif

override_dh_auto_configure:
	dh_auto_configure --                \
		--libdir=$(LIBDIR)          \
		--with-emacsdir=$(EMACSDIR) \
		--with-system-memtailor     \
		--with-system-mathic        \
		--with-system-mathicgb      \
		--with-system-gc            \
		LIBS="$(LIBS)"              \
		$(WITH_PYTHON)              \
		$(DISABLE_DOCUMENTATION)    \
		$(if $(DISABLE_DOCUMENTATION),,--enable-syntax-highlighting)
ifeq ($(DISABLE_DOCUMENTATION),)
	dh_auto_configure --buildsystem=nodejs
	mv node_modules M2/Macaulay2/editors/highlightjs
endif

# copy cached example output files (for examples known to fail on
# various architectures) to source directory
# see generateExamples in debian/scripts/Debian.m2
EXAMPLE_SRC := $(wildcard $(CURDIR)/debian/examples/*)
EXAMPLE_DEST := $(patsubst $(CURDIR)/debian/examples/%, \
	$(CURDIR)/M2/Macaulay2/packages/%/examples, $(EXAMPLE_SRC))

$(CURDIR)/M2/Macaulay2/packages/%/examples: $(CURDIR)/debian/examples/%
	mkdir -p $@
	cp -v $</*.out $@

execute_before_dh_auto_build: $(EXAMPLE_DEST)
	mkdir -p M2/Macaulay2/packages/Style/katex

# since a "test" target exists, dh_auto_test defaults to using that, but
# it just prints the values of some variables.  we want the "check" target
# instead to run the test suite
# related: https://bugs.debian.org/924052
override_dh_auto_test-arch:
	$(MAKE) -C M2 check ArgumentMode="defaultMode - SetUlimit" LIMIT=

ifeq ($(DISABLE_DOCUMENTATION),)
override_dh_auto_test-indep:
	$(MAKE) -C M2 validate-html
endif

# create dumps of package documentation databases to ship with macaulay2-common
# and then load during postinst
PKGLIBDIR := debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/Macaulay2
PKGDOCDIR := debian/tmp/usr/share/doc/Macaulay2
DB_FILENAME := rawdocumentation-$(if \
	$(filter little, $(DEB_HOST_ARCH_ENDIAN)),dcba,abcd)-$(if \
	$(filter 64, $(DEB_HOST_ARCH_BITS)),8,4).db

DB_FILES = $(wildcard $(PKGLIBDIR)/*/cache/$(DB_FILENAME))
DUMP_FILES = $(DB_FILES:$(PKGLIBDIR)/%/cache/$(DB_FILENAME)=\
	$(PKGDOCDIR)/%/dump/rawdocumentation.dump)

$(PKGDOCDIR)/%/dump/rawdocumentation.dump: $(PKGLIBDIR)/%/cache/$(DB_FILENAME)
	mkdir -p $(dir $@)
# gdbm_load records the path of the database file and the timestamp in the
# dump file, so use a relative path and faketime for reproducibility
	cd $(dir $<) && \
		faketime '@$(SOURCE_DATE_EPOCH)' \
		gdbm_dump $(notdir $<) $(CURDIR)/$@

execute_after_dh_auto_install-indep: $(DUMP_FILES)
	rm -rf $(EXAMPLE_DEST)
	for DIR in $(subst /examples,,$(EXAMPLE_DEST)); \
	do if [ -z "$$(ls -A $$DIR)" ]; then rm -rf $$DIR; fi; \
	done
	rm -rf $(PKGLIBDIR) # remove package documentation database files

# https://github.com/Macaulay2/M2/issues/1144
execute_before_dh_link-indep:
	jdupes -rl debian/macaulay2-common/usr/share/doc/Macaulay2

# example output, package test files, and database dumps must be plain text
override_dh_compress:
	dh_compress -Xexample-output -X.m2 -X.dump

execute_before_dh_elpa: debian/macaulay2-pkg.el

debian/macaulay2-pkg.el: debian/macaulay2-pkg.el.in
	sed -e 's|@VERSION@|$(VERSION)|g' $< > $@

# prevent dh_missing from failing when only building arch-dependent packages
execute_before_dh_missing:
	if [ ! -f debian/macaulay2-pkg.el ]; \
	then \
		rm -rf debian/tmp/usr/share/emacs; \
	fi

override_dh_installdeb:
	dh_installdeb --define DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH) \
		--define DB_FILENAME=$(DB_FILENAME)

# we use uscan to check for the most recent version, but to create an
# orig tarball, we also need the contents of the M2-emacs submodule,
# so use this target instead of uscan directly
get-orig-source:
	debian/scripts/m2-get-orig-source.sh

=== debian/tests/control ===
Test-Command: M2 --silent --check 1 -q --stop -E "exit 0"
Depends: macaulay2
Restrictions: allow-stderr
Features: test-name=basic-tests

Test-Command: M2 --check 2
Depends: 4ti2, gfan, macaulay2, normaliz
Restrictions: allow-stderr
Features: test-name=core-tests

Test-Command: M2 --check 3
Depends: 4ti2,
         cohomcalg,
         coinor-csdp,
         gfan,
         libmpfi-dev,
         macaulay2,
         nauty,
         normaliz,
         topcom
Restrictions: allow-stderr
Architecture: !armhf
Features: test-name=package-tests

Test-Command: M2 --script debian/tests/check-doc-db.m2
Depends: macaulay2
Features: test-name=database-smoke-test
